#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for(int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

/**
 * Lessons
 *  - Simulation
 *  - Ensure DP recurrence is correct
 */
int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin.exceptions(cin.failbit);

	int T;
	cin >> T;
	rep(test_case, 0, T) {
		int n, m;
		cin >> n >> m;

		bool ball[n][m];
		rep(row, 0, n) {
			string s;
			cin >> s;
			rep(col, 0, m) {
				ball[row][col] = s[col] == '1';
			}
		}

		bool reach[n][m];
		rep(row, 0, n) rep(col, 0, m) reach[row][col] = false;
		rep(row, 0, n) reach[row][0] = true;
		rep(col, 0, m) reach[0][col] = true;
		rep(row, 1, n) {
			rep(col, 1, m) {
				if(ball[row][col - 1]) reach[row][col] = true;
				else break;
			}
		}
		rep(col, 1, m) {
			rep(row, 1, n) {
				if(ball[row - 1][col]) reach[row][col] = true;
				else break;
			}
		}

		bool valid = true;
		rep(row, 0, n) rep(col, 0, m) if(ball[row][col] && !reach[row][col]) valid = false;
		cout << (valid ? "YES" : "NO") << '\n';
	}
}
